'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _osFamily = require('os-family');

var _osFamily2 = _interopRequireDefault(_osFamily);

var _findWindow = require('./find-window');

var _findWindow2 = _interopRequireDefault(_findWindow);

var _utilsExec = require('../utils/exec');

var _binaries = require('../binaries');

var _binaries2 = _interopRequireDefault(_binaries);

/**
 * Closes the browser window where the specified web page is opened.
 * @function
 * @async
 * @name close
 * @param {string} pageTitle - Specifies the title of the web page opened in the browser.
 */

exports.default = function callee$0$0(pageTitle) {
    var windowDescription, closeWindowArguments;
    return _regeneratorRuntime.async(function callee$0$0$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                context$1$0.next = 2;
                return _regeneratorRuntime.awrap(_findWindow2.default(pageTitle));

            case 2:
                windowDescription = context$1$0.sent;

                if (windowDescription) {
                    context$1$0.next = 5;
                    break;
                }

                return context$1$0.abrupt('return');

            case 5:
                closeWindowArguments = void 0;

                if (!_osFamily2.default.win) {
                    context$1$0.next = 10;
                    break;
                }

                closeWindowArguments = [windowDescription.hwnd];
                context$1$0.next = 19;
                break;

            case 10:
                if (!_osFamily2.default.mac) {
                    context$1$0.next = 14;
                    break;
                }

                closeWindowArguments = [windowDescription.windowId, windowDescription.bundleId];
                context$1$0.next = 19;
                break;

            case 14:
                if (!_osFamily2.default.linux) {
                    context$1$0.next = 18;
                    break;
                }

                closeWindowArguments = [windowDescription.windowId];
                context$1$0.next = 19;
                break;

            case 18:
                return context$1$0.abrupt('return');

            case 19:
                context$1$0.next = 21;
                return _regeneratorRuntime.awrap(_utilsExec.execFile(_binaries2.default.close, closeWindowArguments));

            case 21:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this);
};

module.exports = exports.default;