'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _utilsEnsureDirectory = require('../utils/ensure-directory');

var _utilsEnsureDirectory2 = _interopRequireDefault(_utilsEnsureDirectory);

var _utilsExec = require('../utils/exec');

var _binaries = require('../binaries');

var _binaries2 = _interopRequireDefault(_binaries);

var DEFAULT_THUMBNAIL_WIDTH = 240;
var DEFAULT_THUMBNAIL_HEIGHT = 130;

function getThumbnailPath(imagePath) {
    var imageName = _path2.default.basename(imagePath);
    var imageDir = _path2.default.dirname(imagePath);

    return _path2.default.join(imageDir, 'thumbnails', imageName);
}

/**
 * Creates a thumbnail image from the specified PNG image file.
 * @function
 * @async
 * @name generateThumbnail
 * @param {string} sourcePath - Specifies the path to the source image in PNG format.
 * @param {string} thumbnailPath - Specifies the path to the resulting thumbnail image.
 *                                 Defaults to '<sourcePathDirectory>/thumbnails/<sourcePathFileName>'
 * @param {number} width - Specifies the width of the thumbnail image, in pixels (default is 240).
 * @param {number} height - Specifies the height of the thumbnail image, in pixels (default is 130).
 */

exports.default = function callee$0$0(sourcePath) {
    var thumbnailPath = arguments.length <= 1 || arguments[1] === undefined ? getThumbnailPath(sourcePath) : arguments[1];
    var width = arguments.length <= 2 || arguments[2] === undefined ? DEFAULT_THUMBNAIL_WIDTH : arguments[2];
    var height = arguments.length <= 3 || arguments[3] === undefined ? DEFAULT_THUMBNAIL_HEIGHT : arguments[3];
    return _regeneratorRuntime.async(function callee$0$0$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                return context$1$0.abrupt('return', (function callee$1$0() {
                    return _regeneratorRuntime.async(function callee$1$0$(context$2$0) {
                        while (1) switch (context$2$0.prev = context$2$0.next) {
                            case 0:
                                if (_utilsEnsureDirectory2.default(thumbnailPath)) {
                                    context$2$0.next = 2;
                                    break;
                                }

                                return context$2$0.abrupt('return');

                            case 2:
                                context$2$0.next = 4;
                                return _regeneratorRuntime.awrap(_utilsExec.execFile(_binaries2.default.generateThumbnail, [sourcePath, thumbnailPath, width, height]));

                            case 4:
                            case 'end':
                                return context$2$0.stop();
                        }
                    }, null, this);
                })());

            case 1:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this);
};

module.exports = exports.default;