'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _osFamily = require('os-family');

var _osFamily2 = _interopRequireDefault(_osFamily);

var _os = require('os');

var _findWindow = require('./find-window');

var _findWindow2 = _interopRequireDefault(_findWindow);

var _utilsExec = require('../utils/exec');

var _binaries = require('../binaries');

var _binaries2 = _interopRequireDefault(_binaries);

/**
 * Checks if the specified browser window is maximized.
 * @function
 * @async
 * @name isMaximized
 * @param {string} pageTitle - The title of the web page opened in the window to check if this window is maximized.
 * @return {boolean} `true` if the browser window is maximized
 **/

exports.default = function callee$0$0(pageTitle) {
    var windowDescription, commandArguments, result;
    return _regeneratorRuntime.async(function callee$0$0$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                context$1$0.next = 2;
                return _regeneratorRuntime.awrap(_findWindow2.default(pageTitle));

            case 2:
                windowDescription = context$1$0.sent;

                if (windowDescription) {
                    context$1$0.next = 5;
                    break;
                }

                return context$1$0.abrupt('return', false);

            case 5:
                commandArguments = void 0;

                if (!_osFamily2.default.win) {
                    context$1$0.next = 10;
                    break;
                }

                commandArguments = [windowDescription.hwnd];
                context$1$0.next = 11;
                break;

            case 10:
                return context$1$0.abrupt('return', false);

            case 11:
                context$1$0.next = 13;
                return _regeneratorRuntime.awrap(_utilsExec.execFile(_binaries2.default.maximize, commandArguments.concat('status')));

            case 13:
                result = context$1$0.sent;
                return context$1$0.abrupt('return', result.replace(_os.EOL, '').toLowerCase() === 'true');

            case 15:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this);
};

module.exports = exports.default;

// TODO: implement for macOS